/* PKI ERR Management Functions */

#define __LIBPKI_ERR__

#include <libpki/pki.h>

/* Private variables */
static int pki_err = PKI_OK;
// static char *pki_errval;

/* Externally accessible variable */
char ext_pki_errval[1024];

/* ERR Stack Mutex */
static pthread_mutex_t err_mutex = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t err_cond;

/* Pointer to the Error Stack */
PKI_STACK *pki_err_stack = NULL;

static int _set_pki_errval (int err);
// static char * _get_pki_errval (int err);

/*! \brief Set PKI err (internally used by library functions)
 */

int PKI_set_err ( int err ) {

	pki_err = err;

	if( err > sizeof( pki_errval_strings )) {
		err = 0;
	};

	return ( PKI_OK );
}

/*! \brief Get the current error number */

int PKI_get_err ( void ) {

	return ( pki_err );

}

static int _set_pki_errval (int err) {

	if( err > sizeof( pki_errval_strings )) {
		err = 0;
	};

	return ( PKI_OK );
}

/*! \brief Returns the string pointer to the error value */

const char * PKI_get_strerror ( void ) {
	return ext_pki_errval;
}

